Bug 862293 - Review Request: wsl - shell based wsman client.
Review Request: wsl - shell based wsman client.
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-02 10:32 EDT by Praveen K Paladugu
Modified: 2012-11-18 16:42 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-11-18 16:42:20 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Praveen K Paladugu 2012-10-02 10:32:47 EDT
Spec URL: http://linux.dell.com/files/wsl/wsl.spec
SRPM URL: http://linux.dell.com/files/wsl/wsl-0.1.7c-1.fc16.src.rpm
Description: 

WSL (aka "whistle") contains various scripts that serve as a client interface
to WSMAN or Web Services for Management protocol base on DMTF standard
specification. WSMAN provides standards based messaging for systems management
CIM-style objects.
Comment 1 Mario Blättermann 2012-10-07 08:38:40 EDT
Some initial comments, based on the rpmlint output:

$ rpmlint -i -v *
wsl.src: I: checking
wsl.src: W: spelling-error Summary(en_US) Wsman -> Osman, Woman, Newsman
The value of this tag appears to be misspelled. Please double-check.

wsl.src: W: non-standard-group System/Management
The value of the Group tag in the package is not valid.  Valid groups are:
"Amusements/Games", "Amusements/Graphics", "Applications/Archiving",
"Applications/Communications", "Applications/Databases",
"Applications/Editors", "Applications/Emulators", "Applications/Engineering",
"Applications/File", "Applications/Internet", "Applications/Multimedia",
"Applications/Productivity", "Applications/Publishing", "Applications/System",
"Applications/Text", "Development/Debug", "Development/Debuggers",
"Development/Languages", "Development/Libraries", "Development/System",
"Development/Tools", "Documentation", "System Environment/Base", "System
Environment/Daemons", "System Environment/Kernel", "System
Environment/Libraries", "System Environment/Shells", "Unspecified", "User
Interface/Desktops", "User Interface/X", "User Interface/X Hardware Support".

wsl.src: I: checking-url http://linux.dell.com/files/wsl (timeout 10 seconds)
wsl.src: W: no-%build-section
The spec file does not contain a %build section.  Even if some packages don't
directly need it, section markers may be overridden in rpm's configuration to
provide additional "under the hood" functionality, such as injection of
automatic -debuginfo subpackages.  Add the section, even if empty.

wsl.src: I: checking-url http://linux.dell.com/files/wsl/wsl-0.1.7c.tar.gz (timeout 10 seconds)
wsl.src: W: invalid-url Source0: http://linux.dell.com/files/wsl/wsl-0.1.7c.tar.gz HTTP Error 404: Not Found
The value should be a valid, public HTTP, HTTPS, or FTP URL.

wsl.spec:6: W: non-standard-group System/Management
The value of the Group tag in the package is not valid.  Valid groups are:
"Amusements/Games", "Amusements/Graphics", "Applications/Archiving",
"Applications/Communications", "Applications/Databases",
"Applications/Editors", "Applications/Emulators", "Applications/Engineering",
"Applications/File", "Applications/Internet", "Applications/Multimedia",
"Applications/Productivity", "Applications/Publishing", "Applications/System",
"Applications/Text", "Development/Debug", "Development/Debuggers",
"Development/Languages", "Development/Libraries", "Development/System",
"Development/Tools", "Documentation", "System Environment/Base", "System
Environment/Daemons", "System Environment/Kernel", "System
Environment/Libraries", "System Environment/Shells", "Unspecified", "User
Interface/Desktops", "User Interface/X", "User Interface/X Hardware Support".

wsl.spec: W: no-%build-section
The spec file does not contain a %build section.  Even if some packages don't
directly need it, section markers may be overridden in rpm's configuration to
provide additional "under the hood" functionality, such as injection of
automatic -debuginfo subpackages.  Add the section, even if empty.

wsl.spec: I: checking-url http://linux.dell.com/files/wsl/wsl-0.1.7c.tar.gz (timeout 10 seconds)
wsl.spec: W: invalid-url Source0: http://linux.dell.com/files/wsl/wsl-0.1.7c.tar.gz HTTP Error 404: Not Found
The value should be a valid, public HTTP, HTTPS, or FTP URL.

1 packages and 1 specfiles checked; 0 errors, 7 warnings.


And some more issues from me:

A "Vendor" tag is not needed. Please remove it.

%doc
%{_defaultdocdir}/%{name}-%{version}

This is at least unusual, but probably wrong. You don't have to define the doc folder. Just write:

%doc LICENSE README-wsl VERSION


If you don't want to provide your package for EPEL 5, you have to remove some obsolete stuff (BuildRoot definition, %clean section, initial cleaning of buildroot in %install). The %defattr line is obsolete anyway, even for EPEL 5. Please remove it.
Comment 2 Praveen K Paladugu 2012-10-08 13:16:31 EDT
wsl.src: W: non-standard-group System/Management

Seems like Group tags are optional in Fedora (http://fedoraproject.org/wiki/Packaging:Guidelines#Group_tag), so didn't bother to add a valid one.Added a valid one, to be compatible with EPEL.


** Fixed the URLs for Source files

wsl.src: W: no-%build-section
Added a build section (although empty)


** removed the Vendor tag

** Fixed the listing of doc files

** Removed the BuidRoot definition, %clean section, && %defattr line.


The fixed version of spec file: http://linux.dell.com/files/wsl/wsl.spec
The source rpm: http://linux.dell.com/files/wsl/wsl-0.1.8-1.fc16.src.rpm

Praveen
Comment 3 Mario Blättermann 2012-10-08 13:25:32 EDT
Don't gzip the man page. This happens automatically during the build process.

gzip %{_builddir}/%{name}-%{version}/wsl.1
install -m 644 %{_builddir}/%{name}-%{version}/wsl.1.gz $RPM_BUILD_ROOT%{_mandir}/man1

has to be

install -m 644 %{_builddir}/%{name}-%{version}/wsl.1 $RPM_BUILD_ROOT%{_mandir}/man1


Remove the initial cleaning of buildroot in %install if you don't want to provide your package for EPEL 5.



You don't have to install the doc files explicitely. Drop the following lines:

mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}
install -m 644 %{_builddir}/%{name}-%{version}/LICENSE $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}
install -m 644 %{_builddir}/%{name}-%{version}/README-wsl $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}
install -m 644 %{_builddir}/%{name}-%{version}/VERSION $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}
install -m 644 %{_builddir}/%{name}-%{version}/wsl-config $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}

Because you are adding these files to the %doc macro, the appropriate folder will be created and they will be added automatically.
Comment 4 Praveen K Paladugu 2012-10-08 15:47:07 EDT
Made the changes you suggested, the updated version of spec file: http://linux.dell.com/files/wsl/wsl.spec

updated version of the srpm: http://linux.dell.com/files/wsl/wsl-0.1.8-2.fc16.src.rpm

Thanks
Praveen
Comment 5 Praveen K Paladugu 2012-10-16 10:45:42 EDT
With the review of the package more or less done, could someone please set the review flag and move the BZ along?


Praveen
Comment 6 Mario Blättermann 2012-10-17 16:16:38 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4601097

$ rpmlint -i -v *
wsl.src: I: checking
wsl.src: W: spelling-error Summary(en_US) Wsman -> Osman, Woman, Newsman
The value of this tag appears to be misspelled. Please double-check.

wsl.src: I: checking-url http://linux.dell.com/files/wsl (timeout 10 seconds)
wsl.src:68: W: macro-in-%changelog %doc
Macros are expanded in %changelog too, which can in unfortunate cases lead to
the package not building at all, or other subtle unexpected conditions that
affect the build.  Even when that doesn't happen, the expansion results in
possibly "rewriting history" on subsequent package revisions and generally odd
entries eg. in source rpms, which is rarely wanted.  Avoid use of macros in
%changelog altogether, or use two '%'s to escape them, like '%%foo'.

wsl.src: I: checking-url http://linux.dell.com/files/wsl/wsl-0.1.8.tar.gz (timeout 10 seconds)
wsl.noarch: I: checking
wsl.noarch: E: explicit-lib-dependency libxml2
You must let rpm find the library dependencies by itself. Do not put unneeded
explicit Requires: tags.

wsl.noarch: W: spelling-error Summary(en_US) Wsman -> Osman, Woman, Newsman
The value of this tag appears to be misspelled. Please double-check.

wsl.noarch: I: checking-url http://linux.dell.com/files/wsl (timeout 10 seconds)
wsl.noarch: W: non-conffile-in-etc /etc/wsl/wsl-functions
A non-executable file in your package is being installed in /etc, but is not a
configuration file. All non-executable files in /etc should be configuration
files. Mark the file as %config in the spec file.

wsl.noarch: W: non-conffile-in-etc /etc/wsl/wsl-ws2textc.xsl
A non-executable file in your package is being installed in /etc, but is not a
configuration file. All non-executable files in /etc should be configuration
files. Mark the file as %config in the spec file.

wsl.noarch: W: no-manual-page-for-binary wslecn
Each executable in standard binary directories should have a man page.

wsl.noarch: W: no-manual-page-for-binary wslput
Each executable in standard binary directories should have a man page.

wsl.noarch: W: no-manual-page-for-binary wslinvoke
Each executable in standard binary directories should have a man page.

wsl.noarch: W: no-manual-page-for-binary wslid
Each executable in standard binary directories should have a man page.

wsl.noarch: W: no-manual-page-for-binary wslget
Each executable in standard binary directories should have a man page.

wsl.noarch: W: no-manual-page-for-binary wxmlgetvalue
Each executable in standard binary directories should have a man page.

wsl.noarch: W: no-manual-page-for-binary wslcred
Each executable in standard binary directories should have a man page.

wsl.noarch: W: no-manual-page-for-binary wslenum
Each executable in standard binary directories should have a man page.

wsl.spec:68: W: macro-in-%changelog %doc
Macros are expanded in %changelog too, which can in unfortunate cases lead to
the package not building at all, or other subtle unexpected conditions that
affect the build.  Even when that doesn't happen, the expansion results in
possibly "rewriting history" on subsequent package revisions and generally odd
entries eg. in source rpms, which is rarely wanted.  Avoid use of macros in
%changelog altogether, or use two '%'s to escape them, like '%%foo'.

wsl.spec: I: checking-url http://linux.dell.com/files/wsl/wsl-0.1.8.tar.gz (timeout 10 seconds)
2 packages and 1 specfiles checked; 1 errors, 14 warnings.


Some ignorable spelling errors and missing man pages. The warning about the explicit library is false positive, because we have no system calls during the build, only "install" commands, so that rpm is unable to find the libxml2 dependency anyway.


But one other issue needs to be fixed:

To avoid undesired reactions during the package build, escape always any macros in comments or changelogs with a second %.



Here's the review:

---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    BSD
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    664df855276673de857352a60666057706bb6a4726a6694da66c3f8c99d24c95  wsl-0.1.8.tar.gz
    664df855276673de857352a60666057706bb6a4726a6694da66c3f8c99d24c95  wsl-0.1.8.tar.gz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[.] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: Development files must be in a -devel package.
[.] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[.] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[+] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

----------------

PACKAGE APPROVED

----------------


Please don't forget to escape the %doc macro in %changelog before you import the files into the Git repo.
Comment 7 Gwyn Ciesla 2012-10-18 10:48:56 EDT
No SCM request found.
Comment 8 Praveen K Paladugu 2012-10-18 11:10:49 EDT
New Package SCM Request
=======================
Package Name: wsl
Short Description: Shell based wsman client.
Owners: praveenp
Branches: f17 f18 f19
InitialCC: praveenp
Comment 9 Gwyn Ciesla 2012-10-18 11:40:55 EDT
Git done (by process-git-requests).
Comment 10 Praveen K Paladugu 2012-10-19 11:24:04 EDT
Package Change Request
======================
Package Name: wsl
New Branches: el5 el6
Owners: praveenp
InitialCC: praveenp

The author of the package would like it to be part of EPEL5 and EPEL6 branches as well. Sorry for not listing it above.
Comment 11 Gwyn Ciesla 2012-10-19 11:29:59 EDT
Git done (by process-git-requests).
Comment 12 Mario Blättermann 2012-11-18 16:42:20 EST
Packages have been marked as stable. I close this review request now.

Note You need to log in before you can comment on or make changes to this bug.